;; This file sets up Emacs 19 for the SVRC `Ergo' proof tool.

;; Set up the load path.
(if (not (member "~emacs/site-lisp" load-path))
     (setq load-path
	  (cons "~emacs/site-lisp" load-path))
)

(setq load-path
     (cons "." load-path))

(if (file-exists-p "ergo4") 
    (
     setq ergo-program "ergo_exec_path/ergo4"
	  ergo-mode-version "ergo4-mode"
	  )
  (
   setq ergo-program "ergo_exec_path/ergo"
	ergo-mode-version "ergo-mode"
	)
  )


(defvar ergo-define-function-keys t
"*If this is non-nil, then Ergo Theory Mode defines several
function keys, using F5 to F8.")

;; Add our local info directory to the default info directory list
;; Note that the INFOPATH environment variable overrides this, if set.
(setq Info-default-directory-list
      (cons "~emacs/info" Info-default-directory-list))

;; Set up .thy files to be in Ergo mode.
(setq auto-mode-alist (cons '("\\.thy$" . ergo-theory-mode) auto-mode-alist))
(setq auto-mode-alist (cons '("\\.psc$" . ergo-theory-mode) auto-mode-alist))
(autoload 'ergo-theory-mode ergo-mode-version "Ergo Theory Mode." t)
(autoload 'run-ergo ergo-mode-version "Run the SVRC theorem prover." t)

;; The following lines define some useful function keys.
(if ergo-define-function-keys
  (add-hook 'ergo-theory-mode-hooks
   '(lambda ()
      (define-key ergo-theory-mode-map [f5] 'ergo-send-term)
      (define-key ergo-theory-mode-map [f6] 'ergo-send-rest-of-buffer)
      (define-key ergo-theory-mode-map [f8] 'ergo-send-previous-term)
      )))

;; This may not really be needed (it may be covering up a bug???).
(setq max-specpdl-size 1200)
