%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% This file will be generated automatically eventually.

#include "../lib/ergo.h"

%% builtin_db_cmd(Cmd, Mode).
%%
%%  This lists all the user-callable database commands.
%%  Such tables of commands usually have a third column, which gives
%%  the internal procedure/code that implements the command (whereas
%%  Cmd is the user callable form).  Since they are both the same for
%%  all the database commands, this table only contains the first two
%%  columns.
%%
%%  mode builtin_db_cmd(?nonvar, ?ground).
%%

%% From theory_dag.ql
%% ==================
builtin_db_cmd(add_theory(_),       add_theory(@atom)).
builtin_db_cmd(delete_theory(_),    delete_theory(@theory)).
builtin_db_cmd(delete_theory_and_dependents(_),
                                    delete_theory_and_dependents(@theory)).
builtin_db_cmd(inherit_theory(_),   inherit_theory(@theory)).
builtin_db_cmd(add_subtheory(_),    add_subtheory(@atom)).
builtin_db_cmd(delete_subtheory(_), delete_subtheory(@theory)).
builtin_db_cmd(delete_subtheories_of(_),
                                    delete_subtheories_of(@theory)).
builtin_db_cmd(close_theory,        close_theory).
builtin_db_cmd(cd(T),               cd(@theory)).
%%
%% From theory_data.ql
%% ===================
builtin_db_cmd(declare_name(_),     declare_name(@nonvar)).
builtin_db_cmd(declare_name(_,_),   declare_name(@atom,@arity)).
builtin_db_cmd(declare_param_const(_,_),
                                    declare_param_const(@compound,@code)).
builtin_db_cmd(declare_object_vars(_),
                                    declare_object_vars(@atom)).
builtin_db_cmd(add_axiom(_,_,_,_),  add_axiom(@atom,@list(term),@term,@code)).
builtin_db_cmd(add_param_axiom(_,_,_,_,_),
               add_param_axiom(@atom,@compound,@list(term),@term,@code)).
builtin_db_cmd(define_name(_,_),    define_name(@nonvar, @nonvar)).
builtin_db_cmd(add_tactic_file(_),  add_tactic_file(@filename)).
builtin_db_cmd(require_tactic_file(_),
               require_tactic_file(@filename)).
builtin_db_cmd(add_global_tactic_file(_),
               add_global_tactic_file(@filename)).
builtin_db_cmd(require_global_tactic_file(_),
               require_global_tactic_file(@filename)).
builtin_db_cmd(add_preorder(_),     add_preorder(@atom)).
builtin_db_cmd(add_equivalence(_),  add_equivalence(@atom)).
builtin_db_cmd(add_stronger_than(_,_), add_stronger_than(@atom, @atom)).
builtin_db_cmd(add_reverse_of(_,_), add_reverse_of(@atom, @atom)).

%% Miscellaneous.
%% ===============
builtin_db_cmd(set_verbosity(_),    set_verbosity(@integer)).
builtin_db_cmd(set_batch_mode(_),   set_batch_mode(@truefalse)).
builtin_db_cmd(save_snapshot(_),    save_snapshot(@atom)).

