%% ##include ergo.copyright##
%% 
%% CVS $Id: ergo.h,v 1.29 1999/10/27 15:46:49 itp Exp $

#if defined(QPVERpjr) || defined(QPVERalpha)
%% Temporary fix until we replace all instances of x in prover/global code.
:- compile_time_only(obvar_prefix('x')).
#endif

%% PRE(Label, Predicate)
%% CHECK(Label, Predicate)
%% POST(Label, Predicate)
%% These predicates are the inline preprocessed versions of
%% pre, check and post which are defined in prover/lib/tools.ql and
%% should be used when compile flags are to determine inclusion or
%% exclusion of the check in different versions.
#ifdef NO_PRE
#define PRE(a,b) true
#else
#define PRE(a,b) \
   (\+ \+ (b) -> true \
   ; handle_error(program, ['precondition ',q(a), ' (', q(b), ') failed.']) \
   )
#endif

#ifdef NO_CHECK
#define CHECK(a,b) true
#else
#define CHECK(a,b) \
   (\+ \+ (b) -> true \
   ; handle_error(program, ['assertion ',q(a), ' (', q(b), ') failed.']) \
   )
#endif

#ifdef NO_POST
#define POST(a,b) true
#else
#define POST(a,b) \
   (\+ \+ (b) -> true \
   ; handle_error(program, ['postcondition ',q(a), ' (', q(b), ') failed.']) \
   )
#endif

%% Operators and constants built in to Ergo
%% (these should all be defined in the 'ergo' theory).
#define ERGO_TRUE      'ergo.true'
#define ERGO_IMPLIES   'ergo.=>'
#define ERGO_AND       'ergo.and'
#define ERGO_EQUIV     'ergo.<=>'
#define ERGO_EQUALS    'ergo.='

#if defined(QPVERpjr) || defined(QPVERalpha)
:- compile_time_only(op(600,xfy,(not_free_in))).
#else
:- op(600,xfy,(not_free_in)).
#endif

#ifndef NO_INLINE
% defined in dbms/hook.ql
:- inline(check_or_error(Test,Msg), 
          (Test -> true ; handle_error(data,Msg))).

% defined in lib/tools.ql
:- compile_time_only(inline(debug(Key,Msg), 
         (dbg(Key) ->
            writelist_indent(['DEBUG: ',q(Key),tab|Msg],['DEBUG: ...',tab]),
            writelist([nl]),
            flush_output
         ;
            true
        ))).

% defined in lib/io.ql
:- compile_time_only(inline(writelist(WL), Code, 
      ( list(WL) -> 
          Code = map(writelist_elem, [WL])
      ; open_list(WL) -> 
          Code = noinline_writelist(WL)
      ; 
          write(stderr, 'warning: writelist sees non-list: '), 
          write(stderr, WL),
          nl(stderr), 
          Code = noinline_writelist(WL)
      ))).

% defined in lib/io.ql
:- compile_time_only(inline(writelist_elem(E), Code,
      ( var(E) ->  
          Code = noinline_writelist_elem(E)
      ; functor(E, F, _), var(F) ->
          Code = noinline_writelist_elem(E)
      ; E = nl -> 
          Code = nl
      ; E = tab -> 
          Code = put_code(9)
      ; atom(E) -> 
          Code = write_atom(E)
      ; E = w(T) -> 
          Code = writeRT(T, user)
      ; E = q(T) -> 
          Code = writeRTq(T, user)
      ; 
          Code = noinline_writelist_elem(E)
     ))).
#endif /* NO_INLINE */
