%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% This file will be automatically generated eventually.
%% (and will be more complete than this).

#include "../lib/ergo.h"

builtin_proof_cmd(trans(_),
                  trans(+rulename)).
builtin_proof_cmd(trans(_,_),
                  trans(+rulename,+direction)).
builtin_proof_cmd(trans(_,_,_),
                  trans(+rulename,+direction,+list(rulename))).
builtin_proof_cmd(trans(_,_,_,_),
                  trans(+rulename,+direction,+list(rulename),?thy(term))).

builtin_proof_cmd(h_trans(_,_),
                  h_trans(+rulename, +rulename)).
builtin_proof_cmd(h_trans(_,_,_),
                  h_trans(+rulename, +rulename, +direction)).
builtin_proof_cmd(h_trans(_,_,_,_),
                  h_trans(+rulename, +rulename, +direction, ?list(rulename))).
builtin_proof_cmd(h_trans(_,_,_,_,_),
                  h_trans(+rulename, +rulename, +direction, ?list(rulename), ?thy(term))).

builtin_proof_cmd(d_trans(_,_),
                  d_trans(+hypname, +rulename)).
builtin_proof_cmd(d_trans(_,_,_),
                  d_trans(+hypname, +rulename, +direction)).
builtin_proof_cmd(d_trans(_,_,_,_),
                  d_trans(+hypname, +rulename, +direction, ?list(rulename))).

builtin_proof_cmd(conjecture(_),
                  conjecture(@thy(term))).
builtin_proof_cmd(discharge_conjecture(_),
                  discharge_conjecture(+hypname)).

builtin_proof_cmd(take_theorem(_),
                  take_theorem(+rulename)).
builtin_proof_cmd(take_theorem(_,_),
                  take_theorem(+rulename, ?thy(term))).
builtin_proof_cmd(take_theorem(_,_),
                  take_theorem(+rulename, ?thy(term), -integer)).

builtin_proof_cmd(nfi(_,_),
                  nfi(@obvar,@thy(term))).
builtin_proof_cmd(check_constraints_accepted,
                  check_constraints_accepted).
builtin_proof_cmd(accept_constraints,
                  accept_constraints).
builtin_proof_cmd(inst_var(_,_),
                  inst_var(?thy(term),?thy(term))).
builtin_proof_cmd(promote_var(_),
                  promote_var(?thy(term))).
builtin_proof_cmd(demote_var(_),
                  demote_var(?thy(term))).

builtin_proof_cmd(set_save_proof(_),
                  set_save_proof(@atom)).

builtin_proof_cmd(split_hyp(_),
                  split_hyp(@hypname)).
builtin_proof_cmd(delete_hyp(_),
                  delete_hyp(+hypname)).

builtin_proof_cmd(set_goal,
                  set_goal).
builtin_proof_cmd(set_goal(_),
                  set_goal(@thy(term))).

builtin_proof_cmd(set_verbosity(_),
                  set_verbosity(@integer)).

builtin_proof_cmd(set_write_depth(_),
                  set_write_depth(@integer)).

builtin_proof_cmd(cd(_), cd(@theory)).
