%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS $Id: rules.ql,v 1.3 1999/10/25 18:48:33 itp Exp $


?- op(920, xfy, (=>)).
?- op(810, xfy, (and)).
?- op(999, fx,  (h)).
                                     
                                     
                                     
%% Rule Device Version 1
%%
%% Trans is broken into several peices:
%%
%%	start_trans
%%	set_trans_rule      
%%	set_trans_dir
%%		exists_cond
%%		curr_cond_is_given 
%%		curr_cond_conjecture 
%%	commit_trans
%%
%%
%%  This breakdown is taken directly from the structure of
%%  the search performed by 'search.ql' and 'newuse.ql'.  
%%
%%  It is the
%%  responsibility of the calling predicate(s) to ensure that these calls
%%  take place with newvars thawed.  Further, if the tranformation is on a hyp
%%  it is the calling predicates' responsibility to delete the targeted hyp afterwards.
%%
%%  At present, only one transformation may be active at one
%%  time.  Open_hyp and similar context changing predicates automatically
%%  invalidate any transformation in progress.
%%
%%  The most obvious future enhancement would be to provide for
%%  nested transformations, perhaps with a predicate named
%%  'curr_cond_is_trans'.
%% 
%%   With such an arrangement, this trans command would have the 
%%   functional capabilities of all possible compiled rules.  This would be an
%%   obvious device to use for rerunning altered compiled rules, especially
%%   if the rerun information for the two devices shared a common structure.    
%%
%%   In creating such a facility, it would be necessary to also modify the
%%   discharge capacity to avoid disappointing attempts at constructing
%%   circular discharges.
%%    
 

                                     
                                     
                                     
%% trans data  
%%
%% Implicit parameters:  [tr, FieldName] = Value
%%

td_target( T) :-      ipLookup('tr/target', T).
td_input(T) :-        ipLookup('tr/input', T).
td_rel( T) :-          ipLookup('tr/rel', T).
td_name(T) :-      ipLookup('tr/name', T).
td_stmt(T) :-      ipLookup('tr/stmt', T).
td_body(T) :-       ipLookup('tr/body', T).
td_output( T) :-    ipLookup('tr/output', T).
td_conds( T) :-    ipLookup('tr/conds', T).
td_dir(T) :-          ipLookup('tr/dir', T).
td_newvars(T) :-  ipLookup('tr/newvars', T).
td_antlisttail(T) :- ipLookup('tr/antlisttail', T).                    	
td_antlist(T) :-     ipLookup('tr/antlist', T).    
td_cdep(T) :-     ipLookup('tr/cdep', T).    
td_udep(T) :-     ipLookup('tr/udep', T).    
td_proofterm(T) :-     ipLookup('tr/proofterm', T).    

set_td_antlisttail(T) :- ipSet('tr/antlisttail', T).
set_td_body(T) :- ipSet('tr/body', T).
set_td_conds(T) :- ipSet('tr/conds', T).
set_td_cdep(T) :- ipSet('tr/cdep', T).
set_td_udep(T) :- ipSet('tr/udep', T).
                       
                       
                       
init_td(T, F, Rel, R, D, G, A, PT) :-
	ipSet('tr/target', T),
	ipSet('tr/input', F),
	ipSet('tr/rel', Rel),
	ipSet('tr/name', R),
	ipSet('tr/stmt', _),
	ipSet('tr/body', _),
	ipSet('tr/output', G),
	ipSet('tr/conds', _),
	ipSet('tr/dir', D),
	ipSet('tr/newvars', _),
	ipSet('tr/antlisttail', _),                    	
	ipSet('tr/antlist', A),
	ipSet('tr/cdep', _),
	ipSet('tr/udep', _),
	ipSet('tr/proofterm', PT),
	ipSet(trans_flag, true).



%%  start_trans(+Dest, ?FTerm, ?Rel)
%%
%%  Overrides any transformation already in progress.
%%
%%  Dest == 'focus' | 'null' | 'hyp(N)' | 'discharge(N)' 
%%
%%
start_trans('focus', F, Rel) :-
	!,
	init_td(focus, F, Rel, R, D, G, A, tr(R, D, G, A)),
	ipLookup(focus, F),
	ipLookup(relation, Rel). 
        
start_trans('null', F, Rel) :-      
	!, 
	init_td(null, F, Rel, _, _, _, _, _).
	
start_trans(hyp(N), F, '=>') :-
	!,           	
	is_hyp(N, F),             
	init_td(hyp, F, '=>', R, D, G, A, ht(N, R, D, G, A)).
          
/*
start_trans(discharge(N), F, Rel) :-
	!,                                     
	equal_to(Rel, rev(=>)),
	get_hyp(N, HRec),
	hyp_just(HRec, cj(Just)), var(Just),	
	hyp_term(HRec, F),
	hyp_cdep(HRec, CD),
	hyp_udep(HRec, UD),
	init_td(discharge, F, Rel, R, D, G, A, (Just, tr(R,D,G,A), CD, UD)).	
*/
	



	
%% break_trans
%%
%%   A predicate to be called by operations such as open_pos, which
%%   would invalidate an in-progress transformation.
%%
break_trans :-
	(ipLookup(trans_flag, false) ; ipSet(trans_flag, false)), !.


                                             

%% in_trans
%%
%%   Succeeds iff there is a transformation in progress
%%                                             
in_trans :-
	ipLookup(trans_flag, true).



%% set_trans_rule(+Thy, ?Kind, ?Name, -Body, ?Stmt)
%%
%%   Note that Thy must be instantiated by the calling predicate.
%%   This is something which should be generalized when time permits.
%%
%%   An adaptation of code in 'search.ql'
%%
set_trans_rule(Thy, Kind, Name, Body, Stmt) :-
        
        in_trans, 
        
	td_name(NewName),
	td_body(Body),
	td_cdep(CDep),
	td_udep(UDep),
	td_stmt(Stmt),
	
        (Thy == hyps ->
            Kind = hypothesis,
	    Body = true,
            get_hyp(Name, hrec(NewName,Stmt,_,_,CDep,UDep))
         ;
            CDep = [],
            UDep = [],
	    NewName = (Thy:Name),
            member(Kind, [theorem, axiom, lemma]),
            ([Kind,Thy] : [Name, Stmt, [], Body])
         ;
            Kind = compiled_rule,
            Body = true,
	    NewName = (Thy:cr(Name,_Trace)),
            get_compiled_rule(Thy, Name, _, Concl)
            %%
            %% CDep and UDep are left uninstantiated until the complied rule is
            %% executed.
            %%
            %% Uncertain where to actually execute the compiled rule
        ).
        
        
eval_trans_comprule :-
	td_name(Thy:cr(Name,Trace)), !,
	td_stmt(Stmt),
	td_cdep(CD),
	td_udep(UD),
	once(eval_compiled_rule(Thy, Name, _,_, Stmt, CDep, UDep, Trace)).
	set_td_cdep((CD, CDep)),
	set_td_udep((UD, UDep)).
	        
        
%%  set_dir(Dir, AntList, Conds, Concl, Output)
%%
%%   Performs the 'choose_conditional' and 'choose_direction' 
%%   components of the transformation.
%%
set_trans_dir(Dir, AntList, Conds, Concl, Output) :-
	
	in_trans,
			        %% Get info on the current trans and
	td_input(Input),        %% match it with the arguments of the predicate
	td_output(Output),
	td_antlist(AntList),
	td_antlisttail(AntList),
	td_conds(CondList),
	td_stmt(Stmt),
	td_dir(Dir),
	td_rel(Rel),              
	td_newvars( NewVars),

	choose_conditional(AntList, Stmt, Conds, Concl),
	choose_direction(Dir, Concl, Input, RuleRel, GForm),
	stronger(RuleRel, Rel),
	\+ functor(Concl, rev, 3),

	'$collect_variables'(GForm, var, [], GFVars),
        thawed_sublist(GFVars, [], NewVars),
	Output = GForm,

	conjunct_list(Conds, CondList).


	
%% exists_cond
%%
%%   Succeeds iff there are undischarged conditions of the current transformation.     
%%
%%   NB:  Assumes that we are actually in a transformation.
%%  
exists_cond :-
	td_conds([_|_]).
	    
	    
	    
%% curr_cond_is_given(?RuleName)
%%
%%   Performs search for a rule (hyp/theorem/comprule) which discharges
%%   the current condition. 
%%
%%   NB:  Assumes that we are actually in a transformation.
%%	
curr_cond_is_given(RuleName) :-
	 
	td_conds([Cond|Rest]),           
	set_td_conds(Rest),

        td_antlisttail([TrueName|ALTail]),
	set_td_antlisttail(ALTail),        

	get_th_or_hyp(RuleName, TrueName, Cond, CBody, CD, UD),

	(UD \== []          %% Must be a hypothesis
	->       
  		(CD \== []    %% Depends on conjecture(s)
 		  ->
			td_cdep(CDep),
			set_td_cdep((CD, CDep))
		  ;
		  	true),  
		  	    
		td_udep(UDep),   
		set_td_udep((UD, UDep))	
	;
		(Body \== true   %% Is a rule with executable guard
		  -> 
			td_body(Body),
			set_td_body((Body, CBody)) 
		  ;
		  	true          %% Rule with trival guard
		  )        
	).
	
	

        
%% curr_cond_conjecture(-NewConjNr)
%%
%%   Raise a conjecture to discharge the current condition.
%%                                                                             
%%   NB:  Assumes that we are actually in a transformation.
%%
curr_cond_conjecture(Nr) :-
	
	var(Nr),                       
	
	td_conds([Cond|Rest]),           
        td_antlisttail([TrueName|ALTail]),
	td_cdep(CDep),
	td_udep(UDep),
	
	add_conj(Nr, Cond, CD, UD),
	                                               
	set_td_antlisttail(ALTail),  
	set_td_conds(Rest),
	set_td_cdep((CD, CDep)),
	set_td_udep((UD, UDep)).
	

%% satisfy_conds(?ConjectureList)
%%
%%	Translation of satisfy/3 to the the rule device environment
%%
trans_satisfy([]) :-
	\+ exists_cond, !,
	td_antlisttail([]).
trans_satisfy(ConjList) :-
	curr_cond_is_given(_), !,
	trans_satisfy(ConjList).
trans_satisfy([C|ConjList]) :-
	curr_cond_conjecture(C), !,
	trans_satisfy(ConjList).
	
	                          
%% commit_trans.
%%
%% If there are no outstanding conditions for the transformation,
%% commit_trans will apply the transformation to the proof, 
%% 
%% It is difficult to close off the transformation to further backtracking
%% from this level.  It is the calling predicates 
%% choice as to the level of backtracking into each transformation
%% which might take place.	      
%%                    
trans_commit :-
	
	in_trans,    
	
	\+ exists_cond,   
	td_body(Body), 
	with_frozen_nfi_test(on, once(Body)),
	td_newvars(NV),
	thawing_new_vars(ipSet(newvars, NV)),  %% 'assimilate_new_vars(NV)'  ?
	!,

	td_target(T),
	td_output(G),
	td_cdep(CD),
	td_udep(UD),
	td_proofterm(PT),
	(T == focus
	 ->
	 	ipLookup(proof, P),     
	 	ipLookup(focususe, UDep0),
	 	ipLookup(focusdep, CDep0),	
	 	ipSet(focus, G),
	 	ipSet(proof, [PT|P]),
	 	'$collect_vars'(CD, var, CDep0, CDep),    
	 	ipSet(focusdep, CDep),
	 	ipSet(focususe, [UD|UDep0])
	 ;
	  (T == null  ->
	 	true
	   ;     
	   (T == hyp ->
	 	add_hyp(G, N, ProofTerm, CD, UD)   
	    ;
	 	thaw(ProofTerm),
	 	ProofTerm = tr(R, D, G, A)
	 	%% Discharge not yet implemented
	 ))),
	break_trans.
	 	
                
		
