%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: elves5.ql,v 1.3 2000/11/15 06:29:49 itp Exp $

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% This file defines the 'elves' user interface for proofs.
%%
%% The main features of the elves interface are:
%%
%%    * it defines some abbreviations for common commands like focus.
%%
%%    * it consults the current list of `elves' (proof assistants)
%%      before prompting the user for commands.
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "../prover/lib/ergo.h"

%% TO DO: This file is loaded with useless (to Ergo 5) stuff. Get rid of it.
%% It is basically a duplicate of elves.ql as it was on 11/11/1997
%% (or ``Maintain the Rage Day'' as I prefer to know it) to ensure that a
%% handler for proof_output(_,_) could be added after the add_request call
%% was made. Probably most of the rest of the file can be removed.
%% This bug is basically present because of the unmodularity (if such a word
%% exists) of the emacs interface.
%% MB 11/11/1997
%% Start commenting out bit by bit until nothing is left.

%% setup_elves.
%%
%%  Initialises the database for the elves interface.
%%  Call this when this tactic file is first added to the system.
%%
%%  mode setup_elves.
%%
setup_elves :-
    %% We must declare local (non-saved) facts every session.
%    (theory_fact(elf,2) ->
%        true
%    ;
%        new_theory_fact(elf,2,[save(false)])
%    ),
%    add_handler(deabbreviate_with_type(tactic,T0,T),
%                elves_deabbrev_cmd(T0,T)),
    fail.
setup_elves :-
    query_global(request(proof_output(_,_),_)),
    %% Saved facts/events have already been declared.
    !.
setup_elves :-
    %% Declare all events and saved facts.
%    new_theory_fact(default_elves_list,1,[save(true)]),
%    new_theory_fact(default_active_elves,1,[save(true)]),
    add_request(proof_output(_,_),
                ['proof_output(Kind,Term).', nl,
                 'Kind is: assumption(No), newvars, focus, reln, goal,',
                 ' hyp(HypKind,No)',nl,
                 'HypKind is: discharged, dependent, unused, used.']).

?- setup_elves.

%% These asserted facts store the current elf settings during a proof.
?- dynamic(elves_list/1).
?- dynamic(active_elves/1).

?- dynamic(elves_suspended_state/4).

