%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##



emacs_interface doc
  'Emacs provides special support for editing Ergo files and for',nl,
  'interacting with Ergo.',nl,
  'There are some general ',nl,
  tab, xref([conventions], global, emacs_conventions), nl,
  'for keyboard and mouse use.',nl,
  'If ergo-mode has been correctly installed, finding a file',nl,
  'whose name ends in `.thy'' puts the Emacs buffer in ',nl,
  tab, xref(['ergo-theory-mode'], global, ergo_theory_mode),'.',nl,
  'When Ergo is run inside Emacs, most interaction is via the',nl,
  tab, xref(['interaction frame'], global, interaction_frame),'.',nl,
  nl,
  'During a proof, the following frames become visible:',
  begin(list),
  item([]), xref(['proof frame'], global, proof_frame),
  item([]), xref(['rules frame'], global, rules_frame),
  item([]), xref(['proof script'], global, proof_script),
  end(list),
  nl,
  'The following frames may be generated on request:',
  begin(list),
  item([]), xref(['help frame'], global, help_frame),
  item([]), xref(['edit-elves frame'], global, edit_elves_frame),
  end(list),
  nl,
  'Many aspects of the Emacs interface can be ',nl,
  tab, xref([configured], global, emacs_configuration),nl,
  'to suit personal preferences.'
header
    'The Ergo-Emacs Interface'
extends
  master_help_node.
  
emacs_conventions doc
  'There are some conventions that are observed in several',nl,
  'places within the Ergo-Emacs interface.',nl,nl.

emacs_mouse_conventions doc
  'Text that is ', xref([highlighted], global, emacs_mouse_conventions),
  ' is ', emph(['mouse-active']), '.',nl,
  'When the text is selected, the highlighting changes --',
    ' as when the mouse',nl,
  'moves over a link in a help screen (without clicking).',nl,
  nl,
  'There are two operations on mouse-active text:',nl,
  emph('Selecting'),
    ' text changes the highlight and prepares to do some action;',nl,
  emph('Activating'),
    ' text actually carries out an action.',nl,
  nl,
  'There are two kinds of mouse-active text:',nl,
  emph('Hyperactive'),
    ' text has simple actions associated with it',nl,
  '  (such as following links in the help system), while',nl,
  emph('Reactive'),
    ' text is generally associated with more complex actions',nl,
  '  (such as selecting a subterm of a focus).',nl,
  nl,
  'Hyperactive text is selected simply by moving the mouse over it.',nl,
  'Hyperactive text is activated by clicking mouse button 1 or 2 over it.',nl,
  nl,
  'Reactive text is selected by clicking mouse button 1 over it;',nl,
  'the highlight changes to reflect the selection, and some other',nl,
  'feedback is often given regarding the selection made.',nl,
  'Reactive text is activated by clicking mouse button 2 while it is selected.'
header
  'Mouse Conventions'
extends
  emacs_conventions.

emacs_key_conventions doc
  'Ergo-related buffers fall into two main camps:',nl,
  emph('Read-only'),
  ' buffers are those in which you cannot type normal text.',nl,
  'They include the ', xref('help',global,help_frame), ' and ',
  xref('edit-elves',global,edit_elves_frame), ' frames,',
  ' all panes of the ', xref('proof',global,proof_frame), ' frame,',nl,
  'and the lower two (output) panes of the ',
  xref('rules',global,rules_frame), ' frame.',nl,
  emph('Read-write'),
  ' buffers are those in which you can type normal text.',nl,
  'They include the ', xref('proof script',global,proof_script),
  ' and ', xref(interaction,global,interaction_frame), ' frames.',nl,
  nl,
  'Bindings in the ',
  xref('ergo-common-map',global,ergo_common_map),
  ' are available in all buffers.',nl,
  'Additional bindings in the ',
  xref('ergo-readonly-map',global,ergo_readonly_map),
  ' are available in all buffers.',nl,
  nl,
  'Most buffers will extend the above maps with their own special bindings.',
  nl,nl,
  'You can see the bindings in any buffer at any time with `C-h m'',',nl,
  'or equivalently by selecting `Describe Mode'' from the `Help'' menu.'
header
  'Key Conventions'
extends
  emacs_conventions.

junk doc
  xref('Help frame',global,help_frame), ': k/n/p:',nl,
  '  kill/next/previous: navigate ring of help buffers.',nl,
  xref('Proof frame',global,proof_frame), ': x:',nl,
  '  expand elided (`...'') terms in current window.',nl,
  xref('Hypotheses pane',global,hyps_pane), ': u/f/D:',nl,
  '  use/focus/Discharge selected hypothesis.',nl,
  'The ', xref('rule query',global,rules_query_pane), ', ',
  xref(interaction,global,interaction_frame), ' and ',
  xref('theory-mode',global,ergo_theory_mode), ' buffers have many',nl,
  '  special bindings; follow the links to their specific documentation.',nl,
  nl.

ergo_common_map doc
  'The following key bindings are available in all buffers.',
  nl,
  begin(list),
  item('C-c C-d: run-ergo:'),nl,
  '  ensure there is a visible transcript frame with a running Ergo in it.',
  item('C-c C-w: ergo-toggle-wrapping:'),nl,
  '  toggle between wrapping and truncating lines that are too wide to fit',nl,
  '  on the screen.',
  item('C-c C-l: ergo-refresh-interface:'),nl,
  '  redisplay all proof windows.',
  item('C-c C-e: ergo-end-of-buffer:'),nl,
  '  redisplay the interaction frame, with the insertion point (prompt)',nl,
  '  at the bottom of the buffer.',
  item('C-c C-c: ergo-interrupt:'),nl,
  '  send Ergo an INTR signal, generally resulting in a prompt in the',nl,
  '  interaction window.',
  item('C-h m: ergo-describe-mode:'),nl,
  '  give help on the current buffer''s mode, including key bindings.',
  end(list).

ergo_readonly_map doc
  'The following key bindings are available in all read-only buffers,',nl,
  'in addition to the bindings in the ',
  xref('ergo-common-map',global,ergo_common_map), '.',
  nl,
  begin(list),
  item('h: ergo-describe-mode:'),nl,
  '  give help on the current buffer''s mode, including key bindings.',
  item('>: ergo-scroll-right:'),nl,
  '  scroll window right (text moves left)',
  item('<: ergo-scroll-left:'),nl,
  '  scroll window left (text moves right)',
  end(list).

emacs_menu_conventions doc
  nl
header
  'Menu Conventions'
extends
  emacs_conventions.

ergo_theory_mode doc
  nl.

interaction_frame doc
  nl.

proof_frame doc
  nl.

rules_frame doc
  nl.

proof_script doc
  nl.

help_frame doc
  nl.

edit_elves_frame doc
  nl.

emacs_configuration doc
  nl.
