%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% This file defines the global operators for Ergo 5.
%%
%% CVS $Id: ops5.ql,v 1.10 2001/06/13 03:21:20 itp Exp $

%% any number of minuses from 4..60.
rule_line(----).
rule_line(-----).
rule_line(------).
rule_line(-------).
rule_line(--------).
rule_line(---------).
rule_line(----------).
rule_line(-----------).
rule_line(------------).
rule_line(-------------).
rule_line(--------------).
rule_line(---------------).
rule_line(----------------).
rule_line(-----------------).
rule_line(------------------).
rule_line(-------------------).
rule_line(--------------------).
rule_line(---------------------).
rule_line(----------------------).
rule_line(-----------------------).
rule_line(------------------------).
rule_line(-------------------------).
rule_line(--------------------------).
rule_line(---------------------------).
rule_line(----------------------------).
rule_line(-----------------------------).
rule_line(------------------------------).
rule_line(-------------------------------).
rule_line(--------------------------------).
rule_line(---------------------------------).
rule_line(----------------------------------).
rule_line(-----------------------------------).
rule_line(------------------------------------).
rule_line(-------------------------------------).
rule_line(--------------------------------------).
rule_line(---------------------------------------).
rule_line(----------------------------------------).
rule_line(-----------------------------------------).
rule_line(------------------------------------------).
rule_line(-------------------------------------------).
rule_line(--------------------------------------------).
rule_line(---------------------------------------------).
rule_line(----------------------------------------------).
rule_line(-----------------------------------------------).
rule_line(------------------------------------------------).
rule_line(-------------------------------------------------).
rule_line(--------------------------------------------------).
rule_line(---------------------------------------------------).
rule_line(----------------------------------------------------).
rule_line(-----------------------------------------------------).
rule_line(------------------------------------------------------).
rule_line(-------------------------------------------------------).
rule_line(--------------------------------------------------------).
rule_line(---------------------------------------------------------).
rule_line(----------------------------------------------------------).
rule_line(-----------------------------------------------------------).
rule_line(------------------------------------------------------------). % 60

add_rule_line_operators :-
    rule_line(L),
    add_global_operator(1150, nonassoc, L),
    fail.
add_rule_line_operators.

?- require_global_tactic_file(operator).

init_ops5 :-
    query_global(global_operator(Name, Kind, Prec)),
    msg(operator, ['Deleting global operator: ',
                   q(Prec),' ',q(Kind),' ',q(Name),'.']),
    delete_global_operator(Name, Kind),
    fail.
init_ops5 :-
    msg(operator, ['Defining global operators.']),
    add_global_operator(1190,  prefix,    abbreviation),
    add_global_operator(1190,  prefix,    help),
    add_global_operator(1190,  prefix,    show),
    add_global_operator(1190,  prefix,    set),
    add_global_operator(1190,  prefix,    declare),
    add_global_operator(1190,  prefix,    define),
    add_global_operator(1190,  prefix,    rule),
    add_global_operator(1190,  prefix,    theorem),
    add_global_operator(1190,  prefix,    axiom),
    add_global_operator(1150,  rightassoc,  doc),     %NB: these are not the
    add_global_operator(1150,  rightassoc,  extends), %same as in tac files!
    add_global_operator(1150,  rightassoc,  mode), 
    add_global_operator(1140,  rightassoc,  arity), 
    add_global_operator(1180,  nonassoc,  '==='),
    add_global_operator(1170,  nonassoc,  provided),
    %%
    %% The next group are used for inference rules
    add_rule_line_operators,  %% eg. '----------', precedence=1150
    % ',' separates sequents.  It is rightassoc with precedence=1000.
    % Note that (CName===CSpec) terms must be parenthesized.
    add_global_operator(995,   nonassoc,   ':::'),
    add_global_operator(990,   rightassoc, '--->'),
    add_global_operator(985,   rightassoc, '&&&'),
    add_global_operator(500,   leftassoc,  '+++'),
    add_global_operator(500,   leftassoc,  '---'),
    add_global_operator(500,   leftassoc,  '???'),
    add_global_operator(500,   leftassoc,  '>>>'),
    %%
    %% ---> is also used as a prefix operator by the gumtree interface.
    add_global_operator(990,   prefix,     '--->'),
    %%
    %% My philosophy is that all predicates (=, =<, in etc) should be 700.
    add_global_operator(700,   nonassoc,   not_free_in),
    add_global_operator(700,   nonassoc,   nfi), %% What uses this?
    add_global_operator(700,   nonassoc,   ':'), %% Typed quantifiers.
    %%
    %% '/' is the loosest binding that is allowed within lists, so that
    %% in substitutions like [E/x,F/y], E and F rarely require bracketing.
    add_global_operator(999,   leftassoc,  '/'). %% Substitutions.

?- ( query_global(global_operator(axiom,_,_)) ->  %% the latest operator.
       true
   ;
       init_ops5
   ).
