%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##


%% $Id: output_abbrev.ql,v 1.5 2001/06/04 01:24:11 itp Exp $
%% Provide compatability with `output_abbreviator' hook of previous
%% Ergo releases.
%% THIS IS OBSOLESCENT -- the approved way will be to use abbreviator 
%% and layout hooks.

%% Note a slight change of behaviour: this compatability hook is
%% called only one, on a top-level term; if an output_abbreviator
%% succeeds on that term, that abbreviator will be tried for all subterms.
%%
%% Also note that output_abbreviators should now be global facts not theory
%% facts: searching all ancestors was an awful waste of time!
%%
%% The term is returned as an unbreakable token tree, so the ordinary
%% pretty-printer will not touch it.

%% DAN
%%do_output_abbreviators(Term, Tree, Strm) :-
do_output_abbreviators(Term, Path, Pos0, Pos, Tree, Strm) :-
    global_fact(output_abbreviator,1),
    query_global(output_abbreviator(Abbrev)),
    call_predicate(Abbrev(Term, Pretty, Path, NewPath)),
    !,
    tokenize(Pretty, NewPath, Pos0, Pos, Tree, Strm) 
%% DAN
%%    do_output_abbreviator(Pretty, Abbrev, Term, [], 0, Pos, Strm, Trees, []),
%%    make_nl_tok_tree(no, [], 0, Pos, 0, Trees, [Tree], []).
%%    do_output_abbreviator(Pretty, Abbrev, Term, Path, Pos0, Pos, Strm, Trees, [])
%%    ,
%%    make_nl_tok_tree(no, Path, Pos0, Pos, 0, Trees, [Tree], []).
%%    make_tok_tree(Path, Pos0, Pos, 0, Trees, [Tree], [])
.

%% do_output_abbreviator(Pretty, Abbrev, Term,
%%                       Path, Pos0, Pos, Strm) --> Trees.
%%
%%  Write the result of an output abbreviator into Strm.
%%  That is:
%%   - for each element of Abbr that is an atom, print it (and index it
%%     for the whole abbreviated term).
%%   - for each element of Abbr that is a pair SubTermPath-Indent, set the
%%     indprint_indentation to Indent and then print and index the specified
%%     subterm.
%%
%%  mode do_output_abbreviator(@list(nonvar), @atom, @term,
%%                             @subterm_path, @integer, -integer, @stream,
%%                             @list(compound), -list(compound)).
%%

do_output_abbreviator([], _, _, _, Pos, Pos, _) -->
    [].
do_output_abbreviator([A|Pretty], Abbr, Term, Path, Pos0, Pos, Strm) -->
    {atom(A)},
    !,
    {atom_codes(A, Codes)},
    make_literal(Codes, Path, Pos0, Pos1, Strm),
    do_output_abbreviator(Pretty, Abbr, Term, Path, Pos1, Pos, Strm).
do_output_abbreviator([SP|Pretty], Abbr, Term, Path, Pos0, Pos, Strm) -->
    {
     reverse(SP, SP1),
     our_subterm_path(Term, SP1, SubTerm),
     append(SP, Path, Path1),
     %% ip_lookup(indprint_indentation, Ind0),
     %% ip_set(indprint_indentation, Ind),
     %% DAN 
     %%( nonvar(SubTerm), call_predicate(Abbr(SubTerm, SubPretty)) ->
     %%    do_output_abbreviator(SubPretty, Abbr, SubTerm,
     %%                          Path1, Pos0, Pos1, Strm, SubTrees, []),
     %%    make_tok_tree(Path1, Pos0, Pos1, 0, SubTrees, SubTree)
     %%;
         tokenize(SubTerm, Path1, Pos0, Pos1, SubTree, Strm)
     %%)
     %% ,
     %% ip_set(indprint_indentation, Ind0)
    },
    [SubTree],
    do_output_abbreviator(Pretty, Abbr, Term, Path, Pos1, Pos, Strm).

%%
%%
%% DAN 
%%?- ( query_global(handler(tokenize(_,_,_), do_output_abbreviators(_,_,_))) ->
?- ( query_global(handler(tokenize(_,_,_,_,_,_), do_output_abbreviators(_,_,_,_,_,_))) ->
       true
   ;
%%       add_handler(tokenize(Term, Tree, Strm),
       add_handler(tokenize(Term, Path, Pos0, Pos, Tree, Strm),
%%                   do_output_abbreviators(Term, Tree, Strm)
                   do_output_abbreviators(Term, Path, Pos0, Pos, Tree, Strm)
                  )
   ).

%% our_subterm_path(Term, Path, SubTerm).
%%
%%  Finds Subterm at position Path in Term.
%%  Members of Path that enter quantifier bodies must be of the
%%  b(VarList) form.  Substitutions are evaluated as much as
%%  possible, but will be ignored if they cannot be pushed inside
%%  a quantifier due to lack of information about the distinctness
%%  of object variables.
%%
%%  mode our_subterm_path(@term, ?subterm_path, ?term).
%%
our_subterm_path(Term, [], Term).
our_subterm_path(Term, [P|Path], ST) :-
    compound(Term),
    !,
    functor(Term, F, A),
    F \== param_const,
    between(1, A, P),
    arg(P, Term, Term2),
    our_subterm_path(Term2, Path, ST).
our_subterm_path(Term, [b(Vars)|Path], ST) :-
    quant(Term),
    !,
    quantify(Term2, _,VT,Body),
    Term = Term2,
    get_bound_obvars(VT, Vars),
    our_subterm_path(Body, Path, ST).
our_subterm_path(Term, [2|Path], ST) :-
    quant(Term),
    !,
    quantify(Term, _,_VT,Body0),
    simplify_term(Body0, Body),
    our_subterm_path(Body, Path, ST).
our_subterm_path(Term, [t(N)|Path], ST) :-
    quant(Term),
    quantify(Term2, _,VT,_),
    Term = Term2,
    nth1(N, VT, _:Type),
    our_subterm_path(Type, Path, ST).
our_subterm_path(Term, [1, N |Path], ST) :-
    quant(Term),
    quantify(Term2, _,VT,_),
    Term = Term2,
    nth1(N, VT, _:Type),
    our_subterm_path(Type, Path, ST).

    
general command
  output_abbrev
extends
  general_cmds
mode
  output_abbrev
doc
  'Turn on output abbreviation.'.

output_abbrev :-
    output_abbrev(on).

general command
  output_abbrev(Flag)
extends
  general_cmds
mode
  output_abbrev(?atom)
doc
  'Turn on/off output abbreviation.'.

output_abbrev(on) :-
    query_global(handler(tokenize(_,_,_,_,_,_), 
                 do_output_abbreviators(_,_,_,_,_,_))) ->
       true
   ;
       add_handler(tokenize(Term, Path, Pos0, Pos, Tree, Strm),
                   do_output_abbreviators(Term, Path, Pos0, Pos, Tree, Strm)
                  ).
output_abbrev(off) :-
    delete_handlers(tokenize(_,_,_,_,_,_), 
                    do_output_abbreviators(_,_,_,_,_,_)).
