%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% This file defines theory-level commands that are specific
%% to Ergo 5.
%%
%% CVS $Id: thycmds5.ql,v 1.8 2002/06/27 05:10:28 itp Exp $

#include "../prover/lib/ergo.h"

general command
  show_dependent_rules(Rules)
extends
  general_cmds
doc
  'Lists all the theorems in the accessible theories whose proofs',nl,
  'depend (directly or indirectly) on Rules.',
  para,
  'Rules may be a single rule name of the form Thy:Name, or a list',nl,
  'of rule names of that form.'
mode
  show_dependent_rules(@rulename),
  show_dependent_rules(@list(rulename)).

show_dependent_rules(Rules) :-
    list(Rules),
    !,
    dependent_rules(Rules, Thms),
    writelist(['Theorems that depend on ',q(Rules),' are:',nl]),
    (
        member(Thy:Name, Thms),
        writelist([tab,q(Thy),':',q(Name),nl]),
        fail
    ;
        true
    ).
show_dependent_rules(Rule) :-
    show_dependent_rules([Rule]).

