%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: carith.thy,v 1.4 2002/04/28 05:03:58 itp Exp $

%%%%%%%%%%%%%%%%
%% Arithmetic %%
%%%%%%%%%%%%%%%%

add_theory(carith).
include_theory(stdops, share).
include_theory(cpred_eq_t, all).                                                
include_theory(bools, all).                                                
include_theory(iarith, all).                                                


%% Oracle axioms
axiom do_arith_eq2((Exp1 /= Exp2):thy(term)) ===
     (Exp1 /= Exp2)
      provided  delay_until(ground(Exp1 = Exp2),
                            arith_oracle(Exp1 = Exp2, false)). 
%% Typing theorems
theorem lt_type ===
  if(X:ints and Y:ints,
     (X < Y):bools,
     is_undefined(X < Y)).

theorem le_type ===
  if(X:ints and Y:ints,
     (X =< Y):bools,
     is_undefined(X =< Y)).

theorem lt_is_bool ===
  X:ints and Y:ints => (X < Y):bools.

theorem le_is_bool === 
  X:ints and Y:ints => (X =< Y):bools.
  
