%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: global.thy,v 1.14 2002/06/27 05:10:30 itp Exp $

                          %%%%%%%%%%%%%%%%%%%%%%%%%%%
			  %% Initialize Global.erg %%
                          %%%%%%%%%%%%%%%%%%%%%%%%%%%

%% This file builds an initial global.erg file for Ergo 5.
%%
%% To use this file:  create an empty 'global.erg' file in the current
%% directory, then run a minimal version of Ergo with this file as its
%% standard input, or alternatively, use the macro/1 command to execute 
%% this file. 

%% Set up default path.
%% (No user interface has been defined yet, so we use the 
%%  low level set_parameter equivalent to `set Param === Value').
set_parameter(load_path, ['.', lib(tactics), lib(theories)]).

require_global_tactic_file(operator).
require_global_tactic_file(abbrev).
require_global_tactic_file(dbms).
require_global_tactic_file(newtypes5).  % Ergo 5 types
%% Start up the DBMS interface for this session.
user_interface.

%% Load other important tactic files.
require_global_tactic_file(thycmds).    % Ergo 4&5 commands
require_global_tactic_file(thycmds5).   % Extra Ergo 5 commands
require_global_tactic_file(ops5).       % All global operators
require_global_tactic_file(show).       % Display database contents
require_global_tactic_file(help).       % On-line help.
require_global_tactic_file(gencmds).    % General commands
require_global_tactic_file(prettyrule). % Inference rule concrete syntax
require_global_tactic_file(gumtree).    % Ergo 5 proof user interface.
require_global_tactic_file(gumtree_tactics).    
                                        % Support for gumtree user tactics. 
require_global_tactic_file(gumtree_compiler).    
                                        % The gumtree tactic compiler. 
require_global_tactic_file(showtree).   % Display proof trees textually
require_global_tactic_file(prooffile).  % Save and rerun proof trees.
require_global_tactic_file(treetac).    % The ANGEL/Gumtree tactic language.
%%require_global_tactic_file(dv5).        % Display proof trees graphically 
require_global_tactic_file(rulebrowse5). % Rule browser. 
%require_global_tactic_file(elves5).
require_global_tactic_file(modes_help). % Ergo 5 modes on-line help

set gumtree_display === open(show_nodes_and_context).
