%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: iarith.thy,v 1.10 2003/09/02 00:52:11 itp Exp $

%% An extension of the ints theory that uses oracles to do arithmatic using
%% the dc calculator.

add_theory(iarith).

include_theory(stdops,  share).
include_theory(ints,   all).  


%% Add some extra object variables.
declare_object_vars(w).
declare_object_vars(y).
declare_object_vars(z).


require_tactic_file(iarith,iarith).
require_tactic_file(int_oracle,iarith).

%% Oracle axioms
axiom do_is_int(Exp:thy(term)) ===
    Exp:ints 
      provided  delay_until(ground(Exp), arith_oracle(Exp, _Num)).

axiom do_is_nat(Exp:thy(term)) ===
    Exp:nats 
      provided  delay_until(ground(Exp), arith_oracle(0 =< Exp, true)).

axiom do_arith(Exp:thy(term)) ===
    Exp = Num
      provided  delay_until(ground(Exp), arith_oracle(Exp, Num)).

axiom do_arith_lt(Exp1:thy(term), Exp2:thy(term), Bool:thy(term)) ===
     Exp1 < Exp2 <=> Bool
      provided  delay_until(ground(Exp1 < Exp2), 
                            arith_oracle(Exp1 < Exp2, Bool)).

axiom do_arith_lt1(Exp1:thy(term), Exp2:thy(term)) ===
     Exp1 < Exp2 
      provided  delay_until(ground(Exp1 < Exp2), 
                            arith_oracle(Exp1 < Exp2, true)).

axiom do_arith_lt2(Exp1:thy(term), Exp2:thy(term)) ===
     not (Exp1 < Exp2) 
      provided  delay_until(ground(Exp1 < Exp2), 
                            arith_oracle(Exp1 < Exp2, false)).

axiom do_arith_eq(Exp1:thy(term), Exp2:thy(term), Bool:thy(term)) ===
     Exp1 = Exp2 <=> Bool
      provided  delay_until(ground(Exp1 = Exp2), 
                            arith_oracle(Exp1 = Exp2, Bool)).

axiom do_arith_eq1(Exp1:thy(term), Exp2:thy(term)) ===
     Exp1 = Exp2 
      provided  delay_until(ground(Exp1 = Exp2), 
                            arith_oracle(Exp1 = Exp2, true)).

axiom do_arith_eq2(Exp1:thy(term), Exp2:thy(term)) ===
     not (Exp1 = Exp2) 
      provided  delay_until(ground(Exp1 = Exp2), 
                            arith_oracle(Exp1 = Exp2, false)).


axiom do_arith_le(Exp1:thy(term), Exp2:thy(term)) ===
     Exp1 =< Exp2 <=> Bool
      provided  delay_until(ground(Exp1 =< Exp2), 
                            arith_oracle(Exp1 =< Exp2, Bool)).

axiom do_arith_le1(Exp1:thy(term), Exp2:thy(term)) ===
     Exp1 =< Exp2 
      provided  delay_until(ground(Exp1 =< Exp2), 
                            arith_oracle(Exp1 =< Exp2, true)).

axiom do_arith_le2(Exp1:thy(term), Exp2:thy(term)) ===
     not (Exp1 =< Exp2) 
      provided  delay_until(ground(Exp1 =< Exp2), 
                            arith_oracle(Exp1 =< Exp2, false)).









%%
%% Support for Window Inference - loads
%% iarith specific information.
%%

require_tactic_file(wi_support,iarith).

