%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##


is_bigint(X) :-
    atom(X),
    atom_chars(X, Chars),
    Chars \== [],
    is_list_digits(Chars).

is_list_digits([]).

is_list_digits([D|Rest]) :-
    is_digit(D),
    is_list_digits(Rest).

is_digit('0'). is_digit('1'). is_digit('2'). is_digit('3'). is_digit('4'). 
is_digit('5'). is_digit('6'). is_digit('7'). is_digit('8'). is_digit('9'). 

int_to_bigint(I, I1) :-
    integer(I),
    '>='(I, 0),
    number_codes(I, Codes),
    atom_codes(I1, Codes). 

distinct_bigints_qp(X,Y) :-
    X = param_const('iarith.intconst',X1),
    Y = param_const('iarith.intconst',Y1),
    '\\=='(X1, Y1).

is_int_const(X) :-
    nonvar(X),
    X = param_const(T, Y),
    T == 'iarith.intconst',
    is_bigint(Y).

int_const_to_int(A, N) :-
    nonvar(A),
    A = param_const(T, Y),
    T == 'iarith.intconst',
    atom_codes(Y, Codes),
    number_codes(N, Codes).
