%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: jpred_eq.thy,v 1.9 2002/07/08 03:07:29 itp Exp $
%%
%% Classical Predicate Calculus with Equality
%% ==========================================
%%

add_theory(jpred_eq).
include_theory(stdops,  share).
include_theory(jpred,   all).
include_theory(jprop_eq,      all).
close_theory.


%% Define the unique-existence quantifier.
%%
define ex_one x Body ===
    ex x (Body and (all x2 ([x2/x]Body => x = x2))).


%% TO DO: Include theorems about ex_one.

%% Opening Rules for ex_one
 
theorem open_ex_one_1_fol( x0:obvar ) ===
  hyp ??? nfi(x0) ---> B <=> A
  ----------------
  (ex_one x0 B) <= (ex_one x0 A).
 
theorem open_ex_one_1_imp( x0:obvar ) ===
  hyp ??? nfi(x0) ---> B <=> A
  ----------------
  (ex_one x0 B) => (ex_one x0 A).
 
theorem open_ex_one_1_iff( x0:obvar ) ===
  hyp ??? nfi(x0) ---> B <=> A
  -----------------
  (ex_one x0 B) <=> (ex_one x0 A).        

%% Include lots of one-point theorems.

theorem ex_eq ===
  (ex x x = A) provided
  x not_free_in A.     

theorem ex_eq_rev ===
  (ex x A = x) provided
  x not_free_in A.
 
theorem ex_one_eq ===
  (ex_one x x = A) provided
  x not_free_in A.
 
theorem ex_one_eq_rev ===
  (ex_one x A = x) provided
  x not_free_in A.       

theorem ex_one_iff_ex ===
   (ex_one x x = A and B) <=> (ex x x = A and B)
     provided x not_free_in A.

theorem ex_one_imp_ex ===
    (ex_one x A) => (ex x A).

%%
%% Support for Window Inference - loads
%% jpred_eq specific information.
%%

require_tactic_file(wi_support,jpred_eq).



