%% ##include tactic.copyright##


%% The tactic ``Bite or Swallow'' will either nibble away at a problem
%% (using only the ``safe'' tactics) or swallow the entire problem (using
%% both the ``safe'' and ``unsafe'' tactics).
%%
%% The intention is to provide a tactic which will either complete a
%% proof or leave it in a state in which further work is possible.
%%
%% Safe: The tactic which applies ``safe'' transformations. Depending upon
%%   the context in which the tactic is called, this may be transformations
%%   which do not destroy information.
%% Unsafe: The tactic which applies ``unsafe'' transformations. This may be
%%   those transformations which may either lead to a result or to a
%%   situation from which the proof may not be able to be completed.
%% Result: The tactic called if Bite or Swallow does not complete the proof.

tactic bite_or_swallow( Safe, Unsafe ) ===
bite_or_swallow( Safe, Unsafe, skip ).

tactic bite_or_swallow( Safe, Unsafe, Result ) ===
(   deep( Safe )
;   (!( zero
    '|' all( Unsafe ; bite_or_swallow( Safe, Unsafe ); zero )
    '|' Result
    ))
).

