%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: jprop_eq.thy,v 1.4 2002/07/19 01:18:27 itp Exp $
%%
%% Classical Predicate Calculus with Equality
%% ==========================================
%%

add_theory(jprop_eq).
include_theory(stdops,  share).
include_theory(jprop,   all).
include_theory(weak_eq,      all).

%% 
%% This axiom allows replacement of term A by term B provided
%% A = B is a theorem - the rule does this by making the premise
%% A = B but in the empty hyp context.
 
axiom replace(x:obvar, C:thy(term)) ===
    (hyp === []) ---> A = B
    ---------------------
      [A/x]C = [B/x]C.

axiom eq_true_intro ===
    A
    ----------
    A = true.

close_theory.

theorem eq_true_elim ===
    A = true
    -----------
    A.

theorem eq__iff ===
        A = B
        -----
        A <=> B.

theorem sym_eq ===
  A = B <=> B = A. 

theorem trans_eq ===
  A = B => (A = C <=> C = B).

theorem eq_trans ===
  (A = B) and (B = C) => (A = C).

theorem eq_imp_imp ===
  A = B => (A => B).

theorem eq_imp_iff ===
  (A = B) => (A <=> B).

theorem eq_true ===
  A = true <=> A.
 
theorem true_eq ===
  true = A <=> A.   

%% Opening rules for =

theorem open_eq_1_imp ===
         A = B
   -------------------
    A = C => B = C.

theorem open_eq_2_imp ===
         B = C
   -------------------
    A = B => A = C.

theorem open_eq_1_fol ===
         A = B
   -------------------
    A = C <= B = C.

theorem open_eq_2_fol ===
         B = C
   -------------------
    A = B <= A = C.

theorem open_eq_1_iff ===
         A = B
   -------------------
    A = C <=> B = C.

theorem open_eq_2_iff ===
         B = C
   -------------------
    A = B <=> A = C.


theorem eq_rt ===
      A,
      A = B
  -----------------
      true = B.

theorem eq_rt_ante ===
        H => A,
        H,
        A = B
    --------------
        true = B.
