%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%%
%% CVS $Id: numsets.thy,v 1.3 2004/07/25 04:16:14 itp Exp $

%%%%%%%%%%%%%%%%%%%%%%
%% sets of numbers  %%
%%%%%%%%%%%%%%%%%%%%%%

% A theory about numbers as sets.
% This theory is referred to from the B theories.

[zfc].
delete_theory_and_dependents(numsets).
add_theory(numsets).

include_theory(stdops, share).
%include_theory(iarith,all).
%include_theory(undef,all).
include_theory(zfc,all).
%include_theory(fixedpt,all).
include_theory(ints,all).

%% Add some extra object variables.
declare_object_vars(w).
declare_object_vars(y).
declare_object_vars(z).


% All nats are sets
axiom nats_are_sets ===
    X:nats => X:sets.

define nat === set_of x x:nats.

axiom ex_nats_set ===
    ex_set x x:nats.


% All ints are sets
axiom ints_are_sets ===
    X:ints => X:sets.

define int === set_of x x:ints.

close_theory.

define up_to(A,B) === set_of x (x in int) and (A =< x and x =< B).

theorem nats_type ===
    X:nats
  -------------
   X:sets.

theorem ints_fun_is_fun ===
    all x:sets ex_one y:sets 
          (ex z:nats x = z |--> 0 and y = z) or
          (ex z:nats x = 0 |--> z and y = -z) or
         not (ex z:nats x = z |--> 0 or x = 0 |--> z) and y = empty
    provided
       x not_free_in y, x not_free_in z, y not_free_in z.

theorem ex_ints_set_lemma1 ===
        X:sets
    ---------------------------------------------------
    X in (nat cross single(0)) union (single(0) cross nat)
    <=>
    ex x:nats X = x |--> 0 or X = 0 |--> x
        provided x not_free_in X.
    
theorem ex_ints_set_lemma2 ===
    X:nats, Y:nats
   --------------------------
   A = X |--> 0 and A = 0 |--> Y <=> A = 0 |--> 0 and X = 0 and Y = 0.

theorem ex_ints_set_lemma3 ===
   (ex x:nats A = 0 |--> x) and (ex y:nats A = 0 |--> y  and B = -y) <=> 
      ex y:nats A = 0 |--> y  and B = -y
   provided x not_free_in y, x not_free_in A, x not_free_in B,
            y not_free_in A, y not_free_in B.

theorem ex_ints_set_lemma4 ===
   (ex x:nats A = x |--> 0) and (ex y:nats A = y |--> 0  and B = y) <=> 
      A = B |--> 0 and B:nats
   provided x not_free_in y, x not_free_in A, x not_free_in B,
            y not_free_in A, y not_free_in B.

theorem ex_ints_set ===
    ex_set x x:ints.


theorem ints_type ===
    X:ints
  -------------
   X:sets.

theorem nat_is_set ===
    nat:sets.

theorem int_is_set ===
    int:sets.

theorem nat_property ===
    X:sets
 -------------------
   X in nat <=> X:nats.

theorem int_property ===
    X:sets
 -------------------
   X in int <=> X:ints.

theorem nat_subset_int ===
    nat subset_of int.

theorem up_to_is_set ===
    up_to(A,B):sets.

theorem up_to_property ===
    X:sets
  --------------------
   X in up_to(A,B) <=>  X in int and A =< X and X =< B.

theorem disjoint_adjacent_segments ===
    A:ints, B:ints, C:ints
   -------------------------
    up_to(A,B) inter up_to(B+1,C) = empty.

theorem join_adjacent_segments ===
    A:ints, B:ints, C:ints, A =< B, B+1 =< C
    ----------------------------------------
     up_to(A,B) union up_to(B+1,C) = up_to(A,C).

require_global_tactic_file(wi_support).

save.

