%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: o_pair.thy,v 1.1 2000/10/11 21:37:14 itp Exp $

%%%%%%%%%%%%%%%%%%%
%% Ordered Pairs %%
%%%%%%%%%%%%%%%%%%%


add_theory(o_pair).
include_theory(stdops, share).
include_theory(jpred_eq_t,  all).

define is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) ===
   is_type(Type1) and is_type(Type2) and is_type(PairType) and
   (all x1 all x2 all x3 x1:Type1 and x2:Type2 <=> MkOPair(x1,x2):PairType) and
   (all x1:Type1 all x2:Type2 First(MkOPair(x1,x2)) = x1) and
   (all x1:Type1 all x2:Type2 Second(MkOPair(x1,x2)) = x2) and
   (all x:PairType MkOPair(First(x),Second(x)) = x).

close_theory.

theorem type1_is_type ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    is_type(Type1).

theorem type2_is_type ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    is_type(Type2).

theorem pair_type_is_type ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    is_type(PairType).

theorem ordered_pair_is_ordered_pair ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    (X:Type1 and Y:Type2 => MkOPair(X,Y):PairType).

theorem first_ordered_pair ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    (X:Type1 and Y:Type2 => First(MkOPair(X,Y)) = X).

theorem second_ordered_pair ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    (X:Type1 and Y:Type2 => Second(MkOPair(X,Y)) = Y).

theorem ordered_pair_first_second ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    (P:PairType => MkOPair(First(P),Second(P)) = P).

theorem first_type ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    (P:PairType => First(P):Type1).

theorem second_type ===
  is_ordered_pair(Type1,Type2,PairType,MkOPair,First,Second) =>
    (P:PairType => Second(P):Type2).

