%% ##Copyright##
%%  
%% Copyright (C) 1999 - 2002
%% Software Verification Research Centre
%% The University of Queensland
%% Australia 4072
%%
%% email: svrc@svrc.uq.edu.au
%%
%%
%% The Ergo System and Documentation
%%
%% COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1999 - 2002 by 
%% The University of Queensland, Queensland 4072 Australia
%%
%% Permission to use, copy and distribute this software and associated
%% documentation for any non-commercial purpose and without fee is hereby
%% granted, subject to the following conditions:
%%
%% 1.     that the above copyright notice and this permission notice and
%%        warranty disclaimer appear in all copies and in supporting
%%        documentation;
%%
%% 2.     that the name of The University of Queensland not be used in
%%        advertising or publicity pertaining to distribution of the 
%%        software without specific, written prior permission;
%%
%% 3.     that users of this software should be responsible for determining
%%        the fitness of the software for the purposes for which the 
%%        software is employed by them;
%%
%% 4.     that no changes to the system or documentation are subsequently
%%        made available to third parties or redistributed without prior
%%        written consent from the SVRC; and
%%
%% 5.     that individuals, groups or institutions using this software
%%        register their use by completing the registration form and 
%%        sending the completed registration form to the SVRC.
%%
%% The University of Queensland disclaims all warranties with regard to this
%% software, including all implied warranties of merchantability and fitness
%% to the extent permitted by law. In no event shall The University of
%% Queensland be liable for any special, indirect or consequential damages 
%% or any damages whatsoever resulting from loss of use, data or profits, 
%% whether in an action of contract, negligence or other tortious action, 
%% arising out of or in connection with the use or performance of this 
%% software.
%%
%% THE UNIVERSITY OF QUEENSLAND MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR
%% SUITABILITY OF THIS MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS",
%% WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES.
%%
%%
%% For information on commercial use of this software contact the SVRC.
%%
%% ##Copyright##

%% 
%% CVS $Id: weak_eq.thy,v 1.10 2003/05/05 05:37:56 itp Exp $
%%
%% A theory of weak equality
%% =========================
%%
%% This theory declares an equality relation which has the usual
%% properties of an equivalence relation (reflexivity, symmetry and 
%% transitivity), but does not have the strong replacement axiom.
%%
%% We could build the equivalence properties up via a hierarchy of 
%% theories (reflexive relations, preorders, equivalence relations etc),
%% then use theory interpretation/instantiation to construct this
%% theory.  However, we will be able to do this in a much cleaner
%% and more expressive way when Ergo supports higher order reasoning
%% (eg. preorder(Rel,Type) and sym(Rel,Type) => equiv(Rel,Type)),
%% so we have taken this simpler solution until then.


add_theory(weak_eq).
include_theory(stdops, share).


declare _ = _.

axiom eq_reflex ===
    A = A.

axiom eq__eq ===
    A = B
    ----------
    B = A.

axiom eq__eq__eq ===
    A = B,
    B = C
    ----------
    A = C.

axiom weak_replacement_eq ===
    A,
    A = B
    -----------
    B.
close_theory.


%%
%% Support for Window Inference - loads
%% weak_eq specific information.
%%

require_tactic_file(wi_support,weak_eq).



